Running Storm
=============

This section of the manual covers how to start Storm once it is [installed](md:../Installing_Storm)
on your system. This part of the manual mainly covers how to launch Storm from the command-line or
from other systems. As such, if you are only interested in launching one of the
[programs](md:/Programs) that are distributed alongside Storm, you only need to read the subsection
[running programs](md:Bundled_Programs).

This section covers is structured as follows:

- [Launching Bundled Programs](md:Bundled_Programs)

  This page describes how to launch programs bundled with Storm after installing Storm.

- [Launching Storm in a Terminal](md:In_the_Terminal)

  This page describes how to launch Storm in a terminal. A key part of this is to determine how to
  invoke Storm based on how it was installed on your system. As such, this part is a key
  prerequisite for the following parts of this section.

- [Using the Top Loop](md:The_Top_Loop)

  This page describes how the interactive top-loop in Storm works. It allows you to write and
  evaluate simple expressions and is a good way to experiment with the system.

- [Getting Help](md:Getting_Help)

  This page describes how the built-in help system can be used in the top-loop. The help system
  gives access to the detailed documentation that is built into Storm. It acts as a complement to
  this manual.

- [Running External Code](md:External_Code)

  This page describes how to load and execute larger programs, saved in files on disk. This is
  useful for launching your own programs, programs that are distributed separately from Storm
  itself, or when [developing programs in Storm](md:../Developing_in_Storm).
